﻿Type=Class
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Class_Globals
	Private fx As JFX
	Private pnMain As Pane
	Private pnIndicator As Pane
	Private f_Owner As Form
	Private Wdt, Hgt, Scale As Double
	Private cvs As Canvas
	Private svgBack As GLSVGPath
	Private svgShdw As GLSVGPath
	Private svgStrk As GLSVGPath
	Private svgStrk1 As GLSVGPath
	Private svgCircle As GLCircle
	Private svgIndicator As GLSVGPath
	Private Gold As GLLinearGradient
	Private Shdw As GLRadialGradient
	Type PointApi(X As Double, Y As Double)
	Private Center As PointApi
	'Private FatorMph As Double = 1.609344
	Private fatorMeters_to_Feet As Double = 3.2808399
	Private AltValue, AltOldValue As Int
	Private CompassValue, CompassOldValue As Int
	Private SpeedValue, SpeedOldValue As Int
	Private Cardinals(361) As String
	Private tm As Timer
	Private SpeedFlag As Boolean
	Private AltimeterFlag As Boolean
	Private CompassFlag As Boolean
End Sub

'252.5 x 267.5 px = 100%
Public Sub Initialize(Frm As Form, Scl As Double)
	f_Owner = Frm
	Scale = Scl / 100
	pnMain.Initialize("")
	Wdt = 252.5 * Scale: Hgt = 267.5 * Scale
	Center.X = Wdt / 2
	Center.y = 127 * Scale
	pnMain.PrefWidth = Wdt
	pnMain.PrefHeight = Hgt
	Dim strContent As String = mkContent
	Dim lstG As List = mkLstGoldColors
	Gold.Initialize
	Gold.Create(1, 0.5, 0.5, 1.0,True, "NO_CYCLE", lstG)
	Dim lstB As List = mkLstBlackColors
	Shdw.Initialize
	Shdw.Create(0, 0, 0.5, 0.5, 0.8, True, "NO_CYCLE", lstB)
	
	Dim strkWdt As Double  =  15 * Scale
	svgBack.Initialize
	svgBack.SetFill(fx.Colors.White)
	svgBack.SetStroke(fx.Colors.White)
	svgBack.SetStrokeWidth(strkWdt)
	svgBack.SetSmooth(True)	
	svgBack.SetContent(strContent)
	
	svgShdw.Initialize
	svgShdw.SetFill(Shdw.GetObject)
	svgShdw.SetStrokeWidth(0.0)
	svgShdw.SetSmooth(True)
	svgShdw.SetContent(strContent)
	
	svgStrk1.Initialize
	svgStrk1.SetFill(fx.Colors.Transparent)
	svgStrk1.SetStroke(fx.Colors.DarkGray)
	svgStrk1.SetStrokeWidth(strkWdt)
	svgStrk1.SetSmooth(True)	
	svgStrk1.SetContent(strContent)

	Dim strkWdt As Double  =  13 * Scale
	svgStrk.Initialize
	svgStrk.SetFill(fx.Colors.Transparent)
	svgStrk.SetStroke(Gold.GetObject)
	svgStrk.SetStrokeWidth(strkWdt)
	svgStrk.SetSmooth(True)	
	svgStrk.SetContent(strContent)
	
	svgCircle.Initialize
	svgCircle.Create3(0,0, 73.5 * Scale)	
	svgCircle.SetFill(fx.Colors.Transparent)
	svgCircle.SetStroke(fx.Colors.White)
	svgCircle.SetStrokeWidth(17 * Scale)
	svgCircle.SetSmooth(True)	
	
	cvs.Initialize("cvs")
	pnMain.AddNode(svgBack.AsNode, 0, 0, -1, -1) 
	pnMain.AddNode(cvs, 0, 0, Wdt, Hgt)
	pnMain.AddNode(svgCircle.AsNode, Center.X - svgCircle.GetRadius - 8.5 * Scale, Center.Y - svgCircle.GetRadius - 8.5 * Scale, -1, -1)
	pnMain.AddNode(svgShdw.AsNode, 7.5 * Scale, 7.5 * Scale, -1, -1)
	pnMain.AddNode(svgStrk1.AsNode, 0, 0, -1, -1)
	pnMain.AddNode(svgStrk.AsNode, 1 * Scale, 1 * Scale, -1, -1)
	
	pnIndicator.Initialize("")
	pnIndicator.PrefWidth = 15 * Scale
	pnIndicator.PrefHeight = 200 * Scale
	pnIndicator.Style = "-fx-background-color: transparent;"
	
	svgIndicator.Initialize
	svgIndicator.SetFill(fx.Colors.ARGB(128, 0, 128, 0))
	svgIndicator.SetStroke(fx.Colors.DarkGray)
	svgIndicator.SetStrokeWidth(1 * Scale)
	svgIndicator.SetSmooth(True)
	Dim p(3) As PointApi
	p(0).X = 7.5 * Scale
	p(0).Y = 0.0
	p(1).X = 15 * Scale
	p(1).Y = 32 * Scale
	p(2).X = 0.0
	p(2).Y = 32 * Scale
	strContent = "M" & p(0).X & "," & p(0).Y & " L" & p(1).X & "," & p(1).y & " "  & p(2).X & "," & p(2).y & " Z"
	svgIndicator.SetContent(strContent)	
	pnIndicator.AddNode(svgIndicator.AsNode, 0, 0, -1, -1)	
	pnMain.AddNode(pnIndicator, Center.X - pnIndicator.prefWidth / 2, Center.Y - pnIndicator.PrefHeight / 2, pnIndicator.prefWidth, pnIndicator.PrefHeight)
	RotateNode(pnIndicator, -45)
	'*******  creates the cardinal points
    For i = 1 To 359
        Select Case i
            Case 15, 30, 60, 75, 105, 120, 150, 165, 195, 210, 240, 255, 285, 300, 330, 345
                Cardinals(i) = i
            Case Else
        End Select
    Next
    Cardinals(0) = "N"
    Cardinals(45) = "NE"
    Cardinals(90) = "E"
    Cardinals(135) = "SE"
    Cardinals(180) = "S"
    Cardinals(225) = "SW"
    Cardinals(270) = "W"
    Cardinals(315) = "NW"
    Cardinals(360) = "N"
	DrawSpeedPanel
	DrawAltimeterPanel
	DrawCompassPanel
	SpeedFlag = False
	AltimeterFlag = False
	CompassFlag = False
	tm.Initialize("tm", 10)
End Sub

Private Sub DrawSpeedPanel
    Dim  TickCount, Tickval As Short
    Dim  Stroke As Short
    Dim  strk(5) As Double
	strk(0)= 13 * Scale
	strk(1)= 28 * Scale
	strk(2)= 7 * Scale
	strk(3)= 25 * Scale	
	strk(4)= 38 *Scale
	Dim fz As Double = (11 * Scale) 
	Dim f As Font = fx.CreateFont("System", fz, True, False)
	Dim NewPt(2) As PointApi 
	Dim Radius As Double  = 110  * Scale
	For TickCount = 20 To 260
		Tickval = TickCount - 140
		NewPt(0)= new_pt(Tickval,Radius, Center.X, Center.Y)
    	Stroke = TickCount Mod 10
        If Stroke = 0 Then 
			If (TickCount / 10) Mod 2 <> 0 Then
				NewPt(1) = new_pt(Tickval, Radius - strk(1), Center.X, Center.Y)
			Else
				NewPt(1) = new_pt(Tickval, Radius - strk(0), Center.X, Center.Y)
			End If
			cvs.DrawLine(NewPt(0).x, NewPt(0).y ,NewPt(1).x,NewPt(1).y,fx.Colors.DarkGray, 0.5)
		Else If TickCount Mod 2 = 0 Then
			NewPt(1) = new_pt(Tickval,Radius - strk(2), Center.X, Center. y )
			cvs.DrawLine(NewPt(0).x, NewPt(0).y ,NewPt(1).x, NewPt(1).y, fx.Colors.DarkGray, 0.5)
		End If
        Stroke = TickCount Mod 20
        If Stroke = 0 Then
			NewPt(1) = new_pt(360-Tickval,Radius - strk(3), Center.X, Center.Y)
			cvs.DrawTextRotated(TickCount, NewPt(1).x , NewPt(1).y, f, fx.Colors.DarkGray, "CENTER", TickCount-140)
		End If
	Next
End Sub

Private Sub DrawAltimeterPanel
    Dim y As Double, TickCount As Short, TickVal As Short
    Dim cStart As Short, PicHgt As Double, Stroke As Short
    Dim Radius As Double, strk(4) As Double, cValue As Int
	Dim cFeet As String
	strk(0)= 17 * Scale
	strk(1)= 12 * Scale
	strk(2)= 7 * Scale
	strk(3)= 25 * Scale
	Radius = 65 * Scale
	Dim f As Font = fx.CreateFont("System", 10 * Scale, True, False)
	cvs.DrawCircle(Center.X ,Center.Y, Radius, fx.Colors.White, True,  0)
	cvs.DrawCircle(Center.X ,Center.Y, Radius, fx.Colors.DarkGray, False, 1)
	
	cvs.DrawLine(Center.X, Center.Y - Radius, Center.X, Center.Y + Radius, fx.Colors.DarkGray, 1)
	cvs.DrawLine(Center.X - Radius, Center.y, Center.X + Radius, Center.Y, fx.Colors.red, 1)
	cvs.DrawTextRotated ("Meters",Center.X - Radius + strk(1), Center.Y, f, fx.colors.DarkGray,"CENTER",-90)
	PicHgt =  (125 * Scale) / 60
	cValue = AltOldValue
    cStart = cValue + 30
	cFeet = NumberFormat(cValue * fatorMeters_to_Feet,1,0)
	cvs.DrawText(cValue & " M", Center.X + 5 * Scale, Center.Y - 4 * Scale, f, fx.colors.DarkGray, "LEFT")
	cvs.DrawText(cFeet & " F", Center.X + 5 * Scale, Center.Y + 14 * Scale, f, fx.Colors.DarkGray,"LEFT")

    TickVal = cStart
	For TickCount = 0 To 60
		y = Radius + (PicHgt * TickCount)
        Stroke = TickVal Mod 10
        If Stroke = 0 Then 
			cvs.DrawLine(Center.X - strk(0), y, Center.x, y, fx.Colors.DarkGray, 0.8)
			cvs.DrawText(TickVal, Center.X - strk(3), y + (10 * Scale) / 2, f,  fx.Colors.DarkGray,"RIGHT")
		End If
        Stroke = TickVal Mod 5
        If Stroke = 0 Then
            cvs.DrawLine(Center.X - strk(1), y, Center.X, y, fx.Colors.DarkGray,0.8)
        Else
			cvs.DrawLine(Center.X - strk(2), y, Center.X, y, fx.Colors.DarkGray, 0.8)
        End If		
        TickVal = TickVal - 1
	Next
End Sub

Private Sub DrawCompassPanel
    Dim x As Double, TickCount As Short, TickVal As Short
	Dim lft, tp, cWdt, cHgt As Double
    Dim cStart As Short, cEnd As Short, PicWid As Double, Stroke As Short
    Dim strk(4) As Double, cValue As Int
	Dim f As Font = fx.CreateFont("System", 13 * Scale, True, False)
	cValue = CompassOldValue Mod 360
    cStart = cValue - 30
    cEnd = cValue + 30
    If cStart < 0 Then cStart = 360 + cStart
    If cEnd > 360 Then cEnd = 360 - cEnd
	
	strk(0)= 15 * Scale
	strk(1)= 12 * Scale
	strk(2)= 9 * Scale
	strk(3)= 30 * Scale
	cWdt = 218 * Scale
	cHgt = 38 * Scale
	lft = Center.X - (cWdt / 2) 
	tp = Center.Y + 84 * Scale
	cvs.DrawRect(lft, tp, cWdt, cHgt, fx.Colors.White, True, 0)
	cvs.DrawRect(lft, tp, cWdt, cHgt, fx.Colors.Gray, False, 2 * Scale)
    PicWid = cWdt / 60
    TickVal = cStart
	For TickCount = 0 To 60
		x = PicWid * TickCount
		If TickCount = 30 Then
            cvs.DrawLine(x + lft , tp, x + lft, tp + cHgt , fx.Colors.Red, 2)
 		Else
            Stroke = TickVal Mod 10
            If Stroke = 0 Then cvs.DrawLine(x + lft, tp, x + lft , tp + strk(0), fx.Colors.DarkGray, 0.8)
            Stroke = TickVal Mod 5
            If Stroke = 0 Then
                cvs.DrawLine(x + lft, tp, x + lft, tp + strk(1),fx.Colors.DarkGray,0.8)
            Else
				cvs.DrawLine(x + lft, tp, x + lft, tp + strk(2), fx.Colors.DarkGray,0.8)
            End If
        End If		
        If Cardinals(TickVal) <> "" Then
			cvs.DrawText(Cardinals(TickVal), x + lft, tp + strk(3), f, fx.Colors.DarkGray, "CENTER")
        End If
        TickVal = TickVal + 1
        If TickVal > 360 Then TickVal = TickVal - 360
	Next
End Sub

Public Sub Show(l As Int, t As Int)
	f_Owner.RootPane.AddNode(pnMain, l, t, Wdt, Hgt)
	tm.Enabled = True 
	SpeedOldValue = 160
	SetSpeedValue(0)
End Sub

Public Sub SetSpeedValue(vl As Double)
	SpeedValue = vl
	If SpeedValue < 0 Then SpeedValue = SpeedValue + 360
	SpeedFlag = True
End Sub

Public Sub SetAltimeterValue(Meters As Double)
	AltValue = Meters
	AltimeterFlag = True
End Sub

Public Sub SetCompassValue(vl As Double)
	CompassValue = vl
	CompassFlag = True
End Sub

Private Sub tm_Tick
	If SpeedFlag Then
		If SpeedValue = SpeedOldValue Then
			SpeedFlag = False
		Else
			Dim stp As Short
			If SpeedValue > SpeedOldValue Then
				stp = 1
			Else
				stp = -1
			End If	
			SpeedOldValue = SpeedOldValue + stp
			Dim angle As Int = SpeedOldValue - 140
			RotateNode(pnIndicator, angle)
		End If
	End If
	If AltimeterFlag Then
		If AltValue = AltOldValue Then
			AltimeterFlag = False
		Else
			Dim stp, vl As Short
			Dim ft As Short = Abs(AltOldValue - AltValue)
			vl = ft / 100
			If vl < 1 Then vl = 1
			If AltValue > AltOldValue Then
				stp = vl
			Else
				stp = -vl
			End If	
			AltOldValue = AltOldValue + stp
			DrawAltimeterPanel		
		End If
	End If
	If CompassFlag Then
		If CompassValue = CompassOldValue Then
			CompassFlag = False
		Else
			Dim stp As Short
			If Abs(CompassValue - CompassOldValue) > 180 Then 
				If CompassValue > CompassOldValue Then
					stp = -1
				Else
					stp = 1
				End If
			Else
				If CompassValue > CompassOldValue Then
					stp = 1
				Else
					stp = -1
				End If	
			End If
			CompassOldValue = CompassOldValue + stp
			If CompassOldValue < 0 Then CompassOldValue = 359
			If CompassOldValue > 360 Then CompassOldValue = 1
			DrawCompassPanel	
		End If
	End If
End Sub

Private Sub mkLstGoldColors As List
	Dim stp(8) As GLStop
	Dim p(8) As Paint
	p(0) = fx.Colors.RGB(106, 106, 106)
	p(1) = fx.Colors.RGB(151, 151, 151)
	p(2) = fx.Colors.RGB(197, 197, 197)
	p(3) = fx.Colors.RGB(242, 242,242)
	p(4) = fx.Colors.RGB(106, 106, 106)
	p(5) = fx.Colors.RGB(151, 151, 151)
	p(6) = fx.Colors.RGB(197, 197, 197)
	p(7) = fx.Colors.RGB(242, 242,242)
	Dim lt As List
	lt.Initialize
	For i = 0 To 7
		stp(i).Initialize
		stp(i).Create(i * 0.125, p(i))
		lt.Add(stp(i))
	Next
	Return lt			
End Sub

Private Sub mkLstBlackColors As List
	Dim stp(2) As GLStop
	Dim p(2) As Paint
	p(0) = fx.Colors.Transparent
	p(1) = fx.Colors.DarkGray
	Dim lt As List
	lt.Initialize
	stp(0).Initialize
	stp(1).Initialize
	stp(0).Create(0.4, p(0))
	stp(1).Create(1.0, p(1))
	lt.Add(stp(0))
	lt.Add(stp(1))
	Return lt
End Sub

Private Sub mkContent As String
	Dim pt(8) As PointApi
	pt(0).X = 10 * Scale
	pt(0).y = 197 * Scale
	pt(1).X = -68 * Scale
	pt(1).y = -52 * Scale
	pt(2).X = 303 * Scale
	pt(2).y = -52 * Scale
	pt(3).X = 225 * Scale
	pt(3).y = 197 * Scale
	pt(4).X = 235 * Scale
	pt(4).y = 197 * Scale
	pt(5).X = 235 * Scale
	pt(5).y = 260 * Scale
	pt(6).X = 0
	pt(6).y = 260 * Scale
	pt(7).X = 0
	pt(7).y = 197 * Scale
	Dim str As String  = "M" & pt(0).X & "," & pt(0).y & " " & "C" & pt(1).X & "," & pt(1).y & " " & pt(2).X & "," & pt(2).y & " " & pt(3).X & "," & pt(3).y   
	str = str & " L" & pt(4).X & "," & pt(4).Y  & " " & pt(5).X & "," & pt(5).y   & " " & pt(6).X & "," & pt(6).y
	str = str & " " & pt(7).X & "," & pt(7).y   & " Z"
	Return str
End Sub

Private Sub new_pt(nAngle As Double, r As Double, CX  As Double, CY As Double ) As PointApi 
    Dim AngleRad As Double
	Dim pt As PointApi 
	nAngle = 90 + nAngle
    If nAngle > 360 Then nAngle = nAngle - 360
    AngleRad = nAngle * cPI / 180 'convert to rad
    If AngleRad < 0 Then AngleRad = 6.283 + AngleRad
    pt.x = CX + (r) * Cos(AngleRad)
    pt.Y  = CY - (r) * Sin(AngleRad)
    Return pt
End Sub

Private Sub RotateNode(n As Node, Degree As Double)
 	Dim jo As JavaObject = n
	jo.RunMethod("setRotate", Array(Degree))
End Sub